/* gridframe.c generated by valac 0.56.1, the Vala compiler
 * generated from gridframe.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2015 Michael Catanzaro <mcatanzaro@gnome.org>
 *
 * This file is part of libgnome-games-support.
 *
 * libgnome-games-support is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libgnome-games-support is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libgnome-games-support.  If not, see <http://www.gnu.org/licenses/>.
 */
/* A container that guarantees that the internal allocated space is a fixed*/
/* multiple of an integer. This is a fairly literal translation of the LGPLv2+*/
/* original by Callum McKenzie, itself based on GtkFrame and GtkAspectFrame.*/

#include "libgnome-games-support.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

enum  {
	GAMES_GRID_FRAME_0_PROPERTY,
	GAMES_GRID_FRAME_XPADDING_PROPERTY,
	GAMES_GRID_FRAME_YPADDING_PROPERTY,
	GAMES_GRID_FRAME_WIDTH_PROPERTY,
	GAMES_GRID_FRAME_HEIGHT_PROPERTY,
	GAMES_GRID_FRAME_XALIGN_PROPERTY,
	GAMES_GRID_FRAME_YALIGN_PROPERTY,
	GAMES_GRID_FRAME_NUM_PROPERTIES
};
static GParamSpec* games_grid_frame_properties[GAMES_GRID_FRAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _GamesGridFramePrivate {
	gint _xpadding;
	gint _ypadding;
	gint _xmult;
	gint _ymult;
	gfloat _xalign;
	gfloat _yalign;
	GtkAllocation old_allocation;
};

static gint GamesGridFrame_private_offset;
static gpointer games_grid_frame_parent_class = NULL;

static void games_grid_frame_real_size_allocate (GtkWidget* base,
                                          GtkAllocation* allocation);
static void games_grid_frame_finalize (GObject * obj);
static GType games_grid_frame_get_type_once (void);
static void _vala_games_grid_frame_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_games_grid_frame_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
games_grid_frame_get_instance_private (GamesGridFrame* self)
{
	return G_STRUCT_MEMBER_P (self, GamesGridFrame_private_offset);
}

gint
games_grid_frame_get_xpadding (GamesGridFrame* self)
{
	gint result;
#line 32 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "../games/gridframe.vala"
	result = self->priv->_xpadding;
#line 32 "../games/gridframe.vala"
	return result;
#line 92 "gridframe.c"
}

void
games_grid_frame_set_xpadding (GamesGridFrame* self,
                               gint value)
{
#line 34 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 36 "../games/gridframe.vala"
	if (value >= 0) {
#line 38 "../games/gridframe.vala"
		self->priv->_xpadding = value;
#line 39 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 107 "gridframe.c"
	}
#line 34 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_XPADDING_PROPERTY]);
#line 111 "gridframe.c"
}

gint
games_grid_frame_get_ypadding (GamesGridFrame* self)
{
	gint result;
#line 47 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../games/gridframe.vala"
	result = self->priv->_ypadding;
#line 47 "../games/gridframe.vala"
	return result;
#line 124 "gridframe.c"
}

void
games_grid_frame_set_ypadding (GamesGridFrame* self,
                               gint value)
{
#line 49 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 51 "../games/gridframe.vala"
	if (value >= 0) {
#line 53 "../games/gridframe.vala"
		self->priv->_ypadding = value;
#line 54 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 139 "gridframe.c"
	}
#line 49 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_YPADDING_PROPERTY]);
#line 143 "gridframe.c"
}

gint
games_grid_frame_get_width (GamesGridFrame* self)
{
	gint result;
#line 62 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 62 "../games/gridframe.vala"
	result = self->priv->_xmult;
#line 62 "../games/gridframe.vala"
	return result;
#line 156 "gridframe.c"
}

void
games_grid_frame_set_width (GamesGridFrame* self,
                            gint value)
{
#line 64 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 66 "../games/gridframe.vala"
	if (value > 0) {
#line 68 "../games/gridframe.vala"
		self->priv->_xmult = value;
#line 69 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 171 "gridframe.c"
	}
#line 64 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_WIDTH_PROPERTY]);
#line 175 "gridframe.c"
}

gint
games_grid_frame_get_height (GamesGridFrame* self)
{
	gint result;
#line 77 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../games/gridframe.vala"
	result = self->priv->_ymult;
#line 77 "../games/gridframe.vala"
	return result;
#line 188 "gridframe.c"
}

void
games_grid_frame_set_height (GamesGridFrame* self,
                             gint value)
{
#line 79 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 81 "../games/gridframe.vala"
	if (value > 0) {
#line 83 "../games/gridframe.vala"
		self->priv->_ymult = value;
#line 84 "../games/gridframe.vala"
		gtk_widget_queue_resize ((GtkWidget*) self);
#line 203 "gridframe.c"
	}
#line 79 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_HEIGHT_PROPERTY]);
#line 207 "gridframe.c"
}

gfloat
games_grid_frame_get_xalign (GamesGridFrame* self)
{
	gfloat result;
#line 92 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 92 "../games/gridframe.vala"
	result = self->priv->_xalign;
#line 92 "../games/gridframe.vala"
	return result;
#line 220 "gridframe.c"
}

void
games_grid_frame_set_xalign (GamesGridFrame* self,
                             gfloat value)
{
#line 94 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 96 "../games/gridframe.vala"
	self->priv->_xalign = CLAMP (value, 0.0f, 1.0f);
#line 97 "../games/gridframe.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 94 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_XALIGN_PROPERTY]);
#line 235 "gridframe.c"
}

gfloat
games_grid_frame_get_yalign (GamesGridFrame* self)
{
	gfloat result;
#line 104 "../games/gridframe.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 104 "../games/gridframe.vala"
	result = self->priv->_yalign;
#line 104 "../games/gridframe.vala"
	return result;
#line 248 "gridframe.c"
}

void
games_grid_frame_set_yalign (GamesGridFrame* self,
                             gfloat value)
{
#line 106 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 108 "../games/gridframe.vala"
	self->priv->_yalign = CLAMP (value, 0.0f, 1.0f);
#line 109 "../games/gridframe.vala"
	gtk_widget_queue_resize ((GtkWidget*) self);
#line 106 "../games/gridframe.vala"
	g_object_notify_by_pspec ((GObject *) self, games_grid_frame_properties[GAMES_GRID_FRAME_YALIGN_PROPERTY]);
#line 263 "gridframe.c"
}

GamesGridFrame*
games_grid_frame_construct (GType object_type,
                            gint width,
                            gint height)
{
	GamesGridFrame * self = NULL;
#line 117 "../games/gridframe.vala"
	self = (GamesGridFrame*) g_object_new (object_type, "width", width, "height", height, NULL);
#line 115 "../games/gridframe.vala"
	return self;
#line 276 "gridframe.c"
}

GamesGridFrame*
games_grid_frame_new (gint width,
                      gint height)
{
#line 115 "../games/gridframe.vala"
	return games_grid_frame_construct (GAMES_TYPE_GRID_FRAME, width, height);
#line 285 "gridframe.c"
}

void
games_grid_frame_set (GamesGridFrame* self,
                      gint width,
                      gint height)
{
#line 120 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 122 "../games/gridframe.vala"
	games_grid_frame_set_width (self, width);
#line 123 "../games/gridframe.vala"
	games_grid_frame_set_height (self, height);
#line 299 "gridframe.c"
}

void
games_grid_frame_set_padding (GamesGridFrame* self,
                              gint xpadding,
                              gint ypadding)
{
#line 126 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 128 "../games/gridframe.vala"
	games_grid_frame_set_xpadding (self, xpadding);
#line 129 "../games/gridframe.vala"
	games_grid_frame_set_ypadding (self, ypadding);
#line 313 "gridframe.c"
}

void
games_grid_frame_set_alignment (GamesGridFrame* self,
                                gfloat xalign,
                                gfloat yalign)
{
#line 132 "../games/gridframe.vala"
	g_return_if_fail (self != NULL);
#line 134 "../games/gridframe.vala"
	games_grid_frame_set_xalign (self, xalign);
#line 135 "../games/gridframe.vala"
	games_grid_frame_set_yalign (self, yalign);
#line 327 "gridframe.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 161 "../games/gridframe.vala"
	return self ? g_object_ref (self) : NULL;
#line 335 "gridframe.c"
}

static void
games_grid_frame_real_size_allocate (GtkWidget* base,
                                     GtkAllocation* allocation)
{
	GamesGridFrame * self;
	GtkAllocation _tmp0_;
	gint xsize = 0;
	GtkAllocation _tmp1_;
	gint ysize = 0;
	GtkAllocation _tmp2_;
	gint size = 0;
	GtkAllocation child_allocation = {0};
	GtkAllocation _tmp3_ = {0};
	GtkAllocation _tmp4_;
	GtkAllocation _tmp5_;
	GtkAllocation _tmp6_;
	GtkAllocation _tmp7_;
	GtkAllocation _tmp8_;
	GtkAllocation _tmp9_;
	gboolean _tmp10_ = FALSE;
	GtkWidget* child = NULL;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	gboolean _tmp27_ = FALSE;
	GtkWidget* _tmp28_;
	GtkAllocation _tmp32_;
#line 138 "../games/gridframe.vala"
	self = (GamesGridFrame*) base;
#line 138 "../games/gridframe.vala"
	g_return_if_fail (allocation != NULL);
#line 140 "../games/gridframe.vala"
	_tmp0_ = *allocation;
#line 140 "../games/gridframe.vala"
	GTK_WIDGET_CLASS (games_grid_frame_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_bin_get_type (), GtkBin), &_tmp0_);
#line 142 "../games/gridframe.vala"
	_tmp1_ = *allocation;
#line 142 "../games/gridframe.vala"
	xsize = MAX (1, (_tmp1_.width - self->priv->_xpadding) / self->priv->_xmult);
#line 143 "../games/gridframe.vala"
	_tmp2_ = *allocation;
#line 143 "../games/gridframe.vala"
	ysize = MAX (1, (_tmp2_.height - self->priv->_ypadding) / self->priv->_ymult);
#line 144 "../games/gridframe.vala"
	size = MIN (xsize, ysize);
#line 146 "../games/gridframe.vala"
	_tmp3_.x = 0;
#line 146 "../games/gridframe.vala"
	_tmp3_.y = 0;
#line 146 "../games/gridframe.vala"
	_tmp3_.width = 0;
#line 146 "../games/gridframe.vala"
	_tmp3_.height = 0;
#line 146 "../games/gridframe.vala"
	child_allocation = _tmp3_;
#line 147 "../games/gridframe.vala"
	child_allocation.width = (size * self->priv->_xmult) + self->priv->_xpadding;
#line 148 "../games/gridframe.vala"
	child_allocation.height = (size * self->priv->_ymult) + self->priv->_ypadding;
#line 149 "../games/gridframe.vala"
	_tmp4_ = *allocation;
#line 149 "../games/gridframe.vala"
	_tmp5_ = child_allocation;
#line 149 "../games/gridframe.vala"
	_tmp6_ = *allocation;
#line 149 "../games/gridframe.vala"
	child_allocation.x = (gint) (((_tmp4_.width - _tmp5_.width) * self->priv->_xalign) + _tmp6_.x);
#line 150 "../games/gridframe.vala"
	_tmp7_ = *allocation;
#line 150 "../games/gridframe.vala"
	_tmp8_ = child_allocation;
#line 150 "../games/gridframe.vala"
	_tmp9_ = *allocation;
#line 150 "../games/gridframe.vala"
	child_allocation.y = (gint) (((_tmp7_.height - _tmp8_.height) * self->priv->_yalign) + _tmp9_.y);
#line 152 "../games/gridframe.vala"
	if (gtk_widget_get_mapped ((GtkWidget*) self)) {
#line 414 "gridframe.c"
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		GtkAllocation _tmp14_;
		GtkAllocation _tmp15_;
#line 153 "../games/gridframe.vala"
		_tmp14_ = child_allocation;
#line 153 "../games/gridframe.vala"
		_tmp15_ = self->priv->old_allocation;
#line 153 "../games/gridframe.vala"
		if (_tmp14_.x != _tmp15_.x) {
#line 153 "../games/gridframe.vala"
			_tmp13_ = TRUE;
#line 428 "gridframe.c"
		} else {
			GtkAllocation _tmp16_;
			GtkAllocation _tmp17_;
#line 154 "../games/gridframe.vala"
			_tmp16_ = child_allocation;
#line 154 "../games/gridframe.vala"
			_tmp17_ = self->priv->old_allocation;
#line 154 "../games/gridframe.vala"
			_tmp13_ = _tmp16_.y != _tmp17_.y;
#line 438 "gridframe.c"
		}
#line 153 "../games/gridframe.vala"
		if (_tmp13_) {
#line 153 "../games/gridframe.vala"
			_tmp12_ = TRUE;
#line 444 "gridframe.c"
		} else {
			GtkAllocation _tmp18_;
			GtkAllocation _tmp19_;
#line 155 "../games/gridframe.vala"
			_tmp18_ = child_allocation;
#line 155 "../games/gridframe.vala"
			_tmp19_ = self->priv->old_allocation;
#line 155 "../games/gridframe.vala"
			_tmp12_ = _tmp18_.width != _tmp19_.width;
#line 454 "gridframe.c"
		}
#line 153 "../games/gridframe.vala"
		if (_tmp12_) {
#line 153 "../games/gridframe.vala"
			_tmp11_ = TRUE;
#line 460 "gridframe.c"
		} else {
			GtkAllocation _tmp20_;
			GtkAllocation _tmp21_;
#line 156 "../games/gridframe.vala"
			_tmp20_ = child_allocation;
#line 156 "../games/gridframe.vala"
			_tmp21_ = self->priv->old_allocation;
#line 156 "../games/gridframe.vala"
			_tmp11_ = _tmp20_.height != _tmp21_.height;
#line 470 "gridframe.c"
		}
#line 153 "../games/gridframe.vala"
		_tmp10_ = _tmp11_;
#line 474 "gridframe.c"
	} else {
#line 152 "../games/gridframe.vala"
		_tmp10_ = FALSE;
#line 478 "gridframe.c"
	}
#line 152 "../games/gridframe.vala"
	if (_tmp10_) {
#line 482 "gridframe.c"
		GdkWindow* _tmp22_;
		GtkAllocation _tmp23_;
		GdkRectangle _tmp24_;
#line 158 "../games/gridframe.vala"
		_tmp22_ = gtk_widget_get_window ((GtkWidget*) self);
#line 158 "../games/gridframe.vala"
		_tmp23_ = *allocation;
#line 158 "../games/gridframe.vala"
		_tmp24_ = _tmp23_;
#line 158 "../games/gridframe.vala"
		gdk_window_invalidate_rect (_tmp22_, &_tmp24_, FALSE);
#line 494 "gridframe.c"
	}
#line 161 "../games/gridframe.vala"
	_tmp25_ = gtk_bin_get_child ((GtkBin*) self);
#line 161 "../games/gridframe.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 161 "../games/gridframe.vala"
	child = _tmp26_;
#line 162 "../games/gridframe.vala"
	_tmp28_ = child;
#line 162 "../games/gridframe.vala"
	if (_tmp28_ != NULL) {
#line 506 "gridframe.c"
		GtkWidget* _tmp29_;
#line 162 "../games/gridframe.vala"
		_tmp29_ = child;
#line 162 "../games/gridframe.vala"
		_tmp27_ = gtk_widget_get_visible (_tmp29_);
#line 512 "gridframe.c"
	} else {
#line 162 "../games/gridframe.vala"
		_tmp27_ = FALSE;
#line 516 "gridframe.c"
	}
#line 162 "../games/gridframe.vala"
	if (_tmp27_) {
#line 520 "gridframe.c"
		GtkWidget* _tmp30_;
		GtkAllocation _tmp31_;
#line 163 "../games/gridframe.vala"
		_tmp30_ = child;
#line 163 "../games/gridframe.vala"
		_tmp31_ = child_allocation;
#line 163 "../games/gridframe.vala"
		gtk_widget_size_allocate (_tmp30_, &_tmp31_);
#line 529 "gridframe.c"
	}
#line 165 "../games/gridframe.vala"
	_tmp32_ = child_allocation;
#line 165 "../games/gridframe.vala"
	self->priv->old_allocation = _tmp32_;
#line 138 "../games/gridframe.vala"
	_g_object_unref0 (child);
#line 537 "gridframe.c"
}

static void
games_grid_frame_class_init (GamesGridFrameClass * klass,
                             gpointer klass_data)
{
#line 27 "../games/gridframe.vala"
	games_grid_frame_parent_class = g_type_class_peek_parent (klass);
#line 27 "../games/gridframe.vala"
	g_type_class_adjust_private_offset (klass, &GamesGridFrame_private_offset);
#line 27 "../games/gridframe.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) games_grid_frame_real_size_allocate;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_games_grid_frame_get_property;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_games_grid_frame_set_property;
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (klass)->finalize = games_grid_frame_finalize;
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_XPADDING_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_XPADDING_PROPERTY] = g_param_spec_int ("xpadding", "xpadding", "xpadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_YPADDING_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_YPADDING_PROPERTY] = g_param_spec_int ("ypadding", "ypadding", "ypadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_WIDTH_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_HEIGHT_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_XALIGN_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_XALIGN_PROPERTY] = g_param_spec_float ("xalign", "xalign", "xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../games/gridframe.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAMES_GRID_FRAME_YALIGN_PROPERTY, games_grid_frame_properties[GAMES_GRID_FRAME_YALIGN_PROPERTY] = g_param_spec_float ("yalign", "yalign", "yalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 568 "gridframe.c"
}

static void
games_grid_frame_instance_init (GamesGridFrame * self,
                                gpointer klass)
{
#line 27 "../games/gridframe.vala"
	self->priv = games_grid_frame_get_instance_private (self);
#line 29 "../games/gridframe.vala"
	self->priv->_xpadding = 0;
#line 44 "../games/gridframe.vala"
	self->priv->_ypadding = 0;
#line 59 "../games/gridframe.vala"
	self->priv->_xmult = 1;
#line 74 "../games/gridframe.vala"
	self->priv->_ymult = 1;
#line 89 "../games/gridframe.vala"
	self->priv->_xalign = 0.5f;
#line 101 "../games/gridframe.vala"
	self->priv->_yalign = 0.5f;
#line 589 "gridframe.c"
}

static void
games_grid_frame_finalize (GObject * obj)
{
	GamesGridFrame * self;
#line 27 "../games/gridframe.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 27 "../games/gridframe.vala"
	G_OBJECT_CLASS (games_grid_frame_parent_class)->finalize (obj);
#line 600 "gridframe.c"
}

static GType
games_grid_frame_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesGridFrameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_grid_frame_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesGridFrame), 0, (GInstanceInitFunc) games_grid_frame_instance_init, NULL };
	GType games_grid_frame_type_id;
	games_grid_frame_type_id = g_type_register_static (gtk_bin_get_type (), "GamesGridFrame", &g_define_type_info, 0);
	GamesGridFrame_private_offset = g_type_add_instance_private (games_grid_frame_type_id, sizeof (GamesGridFramePrivate));
	return games_grid_frame_type_id;
}

GType
games_grid_frame_get_type (void)
{
	static volatile gsize games_grid_frame_type_id__once = 0;
	if (g_once_init_enter (&games_grid_frame_type_id__once)) {
		GType games_grid_frame_type_id;
		games_grid_frame_type_id = games_grid_frame_get_type_once ();
		g_once_init_leave (&games_grid_frame_type_id__once, games_grid_frame_type_id);
	}
	return games_grid_frame_type_id__once;
}

static void
_vala_games_grid_frame_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	GamesGridFrame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 27 "../games/gridframe.vala"
	switch (property_id) {
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_xpadding (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_ypadding (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_WIDTH_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_width (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_HEIGHT_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_int (value, games_grid_frame_get_height (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_float (value, games_grid_frame_get_xalign (self));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		g_value_set_float (value, games_grid_frame_get_yalign (self));
#line 27 "../games/gridframe.vala"
		break;
#line 671 "gridframe.c"
		default:
#line 27 "../games/gridframe.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../games/gridframe.vala"
		break;
#line 677 "gridframe.c"
	}
}

static void
_vala_games_grid_frame_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	GamesGridFrame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAMES_TYPE_GRID_FRAME, GamesGridFrame);
#line 27 "../games/gridframe.vala"
	switch (property_id) {
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_xpadding (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YPADDING_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_ypadding (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_WIDTH_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_width (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_HEIGHT_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_height (self, g_value_get_int (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_XALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_xalign (self, g_value_get_float (value));
#line 27 "../games/gridframe.vala"
		break;
#line 27 "../games/gridframe.vala"
		case GAMES_GRID_FRAME_YALIGN_PROPERTY:
#line 27 "../games/gridframe.vala"
		games_grid_frame_set_yalign (self, g_value_get_float (value));
#line 27 "../games/gridframe.vala"
		break;
#line 727 "gridframe.c"
		default:
#line 27 "../games/gridframe.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../games/gridframe.vala"
		break;
#line 733 "gridframe.c"
	}
}

